// bitmap header dump.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdlib.h>

int main(int argc, char* argv[])
{
	FILE *bitmap;
	const char *bitmap_BM = "BM";
	char temp[3];
	unsigned char bitmap_data = 0;
	unsigned int temp_idx = 0;
	unsigned int temp_idx_2 = 0;
	unsigned int temp_idx_max = 0;
	unsigned int file_len = 0;
	BITMAPFILEHEADER	header;
	BITMAPINFO			bitmap_info;
	RGBQUAD				*rgbquad = NULL;
	RGBTRIPLE			rgbtriple;

	// ϸ    ó
	if(argc != 2)
	{
		printf("usage : %s [filename.ext]\n",argv[0]);
		return -1;
	}

	//     ó
	bitmap = fopen(argv[1],"rb");
	if(bitmap == NULL)
	{
		printf("Invalide File, please check filename\n");
		return -1;
	}

	fread(&header,1,sizeof(BITMAPFILEHEADER),bitmap);	//   б
	fread(&bitmap_info,1,sizeof(BITMAPINFO),bitmap);	// Ʈ  б
	//   
	fseek(bitmap,0,SEEK_END);
	file_len = ftell(bitmap);

	printf("\n------------------------------");
	printf("\n BitMap Header Reader");
	printf("\n Alpha version");
	printf("\n------------------------------");
	printf("\n Filename [%s]",argv[1]);
	printf("\n");
		memcpy(temp,&(header.bfType),2); temp[2] = 0x00;
		if(strcmp(temp,bitmap_BM) != 0)
		{
			printf("\nBitmap file needed!");
			return -1;
		}
	printf("\n === File Header ===");
	printf("\n\t           Type : [BM]");
	printf("\n\t           Size : [%d:%d]",header.bfSize,file_len);
		if(header.bfSize != file_len) printf(" - Broken or invalid file");
	printf("\n\t        Offbits : [%d]",header.bfOffBits);
		if(header.bfSize != (header.bfOffBits + bitmap_info.bmiHeader.biSizeImage)) printf(" - Broken or invalid file");
	printf("\n ");
	printf("\n === BitMap Info ===");
	printf("\n\t         biSize : [%d]",bitmap_info.bmiHeader.biSize);
		if(bitmap_info.bmiHeader.biSize != 40) printf(" - Broken or invalid file");
		else printf(" - size of BITMAPINFO");
	printf("\n\t        biWidth : [%d]",bitmap_info.bmiHeader.biWidth);
		if(bitmap_info.bmiHeader.biWidth < 0) printf(" - Broken or invalid file");
	printf("\n\t       biHeight : [%d]",bitmap_info.bmiHeader.biHeight);
		if(bitmap_info.bmiHeader.biHeight < 0) printf(" - Broken or invalid file");
	printf("\n\t       biPlanes : [%d]",bitmap_info.bmiHeader.biPlanes);
		if(bitmap_info.bmiHeader.biPlanes != 1) printf(" - Broken or invalid file");
	printf("\n\t     biBitCount : [%d]",bitmap_info.bmiHeader.biBitCount);
		switch(bitmap_info.bmiHeader.biBitCount)
		{
			case  0:	printf(" - JPEG or PNG"); break;
			case  1:	printf(" - 2 color"); break;
			case  4:	printf(" - 16 color"); break;
			case  8:	printf(" - 256 color"); break;
			case 16:	printf(" - 16bit bitmap"); break;
			case 24:	printf(" - 24bit bitmap"); break;
			case 32:	printf(" - 32bit bitmap"); break;
			default:	printf(" - Broken or invalid file"); break;
		}
	printf("\n\t  biCompression : [%d]",bitmap_info.bmiHeader.biCompression);
		switch(bitmap_info.bmiHeader.biCompression)
		{
			case BI_RGB:		printf(" - uncompressed"); break;
			case BI_RLE8:		printf(" - RLE 8bpp"); break;
			case BI_RLE4:		printf(" - RLE 4bpp"); break;
			case BI_BITFIELDS:	printf(" - uncompressed for 16/32bit bitmap"); break;
//			case BI_JPEG:		printf(" - JPEG"); break;
//			case BI_PNG:		printf(" - PNG"); break;
			default :			printf(" - Broken or invalid file"); break;
		}
	printf("\n\t    biSizeImage : [%d]",bitmap_info.bmiHeader.biSizeImage);
		printf(" - size of pure Bitmap data");
	printf("\n\tbiXPelsPerMeter : [%d]",bitmap_info.bmiHeader.biXPelsPerMeter);
		printf(" X resolution by PPM");
	printf("\n\tbiYPelsPerMeter : [%d]",bitmap_info.bmiHeader.biYPelsPerMeter);
		printf(" Y resolution by PPM");
	printf("\n\t      biClrUsed : [%d]",bitmap_info.bmiHeader.biClrUsed);
		if(bitmap_info.bmiHeader.biClrUsed == 0) printf(" - All color used");
		else printf(" - palette");
	printf("\n\t biClrImportant : [%d]",bitmap_info.bmiHeader.biClrImportant);
		if(bitmap_info.bmiHeader.biClrImportant == 0) printf(" - All color required");
		else printf(" require %d color index",bitmap_info.bmiHeader.biClrImportant);

	// Pallette Data
	// bitmap_info.bmiColors; // RGBQUAD
	switch(bitmap_info.bmiHeader.biBitCount)
	{
		// no pallet
		case  0:	// JPEG or PNG
		case 24:	// 24bit
		case 32:	// 32bit
		default:	// error
			break;
		// pallet
		case  1:	temp_idx_max = 2; break; /* 1bit 2 color */
		case  4:	temp_idx_max = 16; break; /* 4bit 16 color */
		case 16:	temp_idx_max = 65536; break; /* 16bit */
		case  8:	 /* 8bit 256 color */
			temp_idx_max = bitmap_info.bmiHeader.biClrImportant;
			if(temp_idx_max == 0) temp_idx_max = 256;
			break;
	}

	switch(bitmap_info.bmiHeader.biBitCount)
	{
		case 1:
		case 4:
		case 8:
			printf("\n ");
			printf("\n === Pallete ===           dec | hex");
			printf("\n [index] [ red ][green][ blue]   [   r g b]");
			
			fseek(bitmap,54,SEEK_SET);
			rgbquad = (RGBQUAD*)malloc(sizeof(RGBQUAD)*temp_idx_max);
			fread(rgbquad,sizeof(RGBQUAD),temp_idx_max,bitmap);

			for(temp_idx = 0; temp_idx < temp_idx_max ; temp_idx++)
			{
				printf("\n [%5d] [%5d][%5d][%5d] | [0x%02X%02X%02X]",temp_idx,
				rgbquad[temp_idx].rgbRed,
				rgbquad[temp_idx].rgbGreen,
				rgbquad[temp_idx].rgbBlue,
				rgbquad[temp_idx].rgbRed,
				rgbquad[temp_idx].rgbGreen,
				rgbquad[temp_idx].rgbBlue);
			}
			break;
	}

	// bitmap data display
	unsigned char bit_mod = 0;
	switch(bitmap_info.bmiHeader.biBitCount)
	{
		case 1:
			printf("\n");
			printf("\n === Bitmap Data[Indexed data] ===");
			fseek(bitmap,header.bfOffBits,SEEK_SET);
			bit_mod = (4 - (bitmap_info.bmiHeader.biWidth % 4)) % 4;
			temp_idx_max = header.bfSize - header.bfOffBits - bit_mod * bitmap_info.bmiHeader.biHeight ; // data length
			
			printf("\n[");
			for(temp_idx = 0; temp_idx < temp_idx_max ; temp_idx++)
			{
				if(temp_idx % (bitmap_info.bmiHeader.biWidth >> 3) == 0 && temp_idx != 0)
				{
					printf("] - %d\n[",temp_idx / (bitmap_info.bmiHeader.biWidth >> 3));
					fseek(bitmap,bit_mod,SEEK_CUR);
				}
				fread(&bitmap_data,1,1,bitmap);
				for(temp_idx_2 = 0; temp_idx_2 < 8 ; temp_idx_2++)
					printf("%c",((bitmap_data >> temp_idx_2) & 0x01)==0?' ':'8');
					//printf("%02X ",bitmap_data);
			}
			printf("] - %d\n",temp_idx / (bitmap_info.bmiHeader.biWidth >> 3));

			// bitmap data
			printf("\n");
			printf("\n === Bitmap Data[RGB translated] ===");
			fseek(bitmap,header.bfOffBits,SEEK_SET);

			printf("\n[");
			for(temp_idx = 0; temp_idx < temp_idx_max ; temp_idx++)
			{
				if(temp_idx % bitmap_info.bmiHeader.biWidth == 0 && temp_idx != 0)
				{
					printf("] - %d\n[",temp_idx / bitmap_info.bmiHeader.biWidth);
					fseek(bitmap,bit_mod,SEEK_CUR);
				}
				fread(&bitmap_data,1,1,bitmap);
				printf("0x%02X%02X%02X ",rgbquad[bitmap_data].rgbRed,rgbquad[bitmap_data].rgbGreen,rgbquad[bitmap_data].rgbBlue);
			}
			printf("] - %d\n",temp_idx / bitmap_info.bmiHeader.biWidth);
			break;

		case 4:
		case 8:
		case 16:
			// bitmap data
			printf("\n");
			printf("\n === Bitmap Data[Indexed data] ===");
			fseek(bitmap,header.bfOffBits,SEEK_SET);
			bit_mod = (4 - (bitmap_info.bmiHeader.biWidth % 4)) % 4;
			temp_idx_max = header.bfSize - header.bfOffBits - bit_mod * bitmap_info.bmiHeader.biHeight ; // data length
			
			printf("\n[");
			for(temp_idx = 0; temp_idx < temp_idx_max ; temp_idx++)
			{
				if(temp_idx % bitmap_info.bmiHeader.biWidth == 0 && temp_idx != 0)
				{
					printf("] - %d\n[",temp_idx / bitmap_info.bmiHeader.biWidth);
					fseek(bitmap,bit_mod,SEEK_CUR);
				}
				fread(&bitmap_data,1,1,bitmap);
				printf("%02X ",bitmap_data);
			}
			printf("] - %d\n",temp_idx / bitmap_info.bmiHeader.biWidth);

			// bitmap data
			printf("\n");
			printf("\n === Bitmap Data[RGB translated] ===");
			fseek(bitmap,header.bfOffBits,SEEK_SET);

			printf("\n[");
			for(temp_idx = 0; temp_idx < temp_idx_max ; temp_idx++)
			{
				if(temp_idx % bitmap_info.bmiHeader.biWidth == 0 && temp_idx != 0)
				{
					printf("] - %d\n[",temp_idx / bitmap_info.bmiHeader.biWidth);
					fseek(bitmap,bit_mod,SEEK_CUR);
				}
				fread(&bitmap_data,1,1,bitmap);
				printf("0x%02X%02X%02X ",rgbquad[bitmap_data].rgbRed,rgbquad[bitmap_data].rgbGreen,rgbquad[bitmap_data].rgbBlue);
			}
			printf("] - %d\n",temp_idx / bitmap_info.bmiHeader.biWidth);
			break;

		case 24:
			// bitmap data
			printf("\n");
			printf("\n === Bitmap Data ===");
			fseek(bitmap,header.bfOffBits,SEEK_SET);
			printf("\n[");
			temp_idx_max = bitmap_info.bmiHeader.biWidth * bitmap_info.bmiHeader.biHeight;
			bit_mod = ((bitmap_info.bmiHeader.biWidth * sizeof(RGBTRIPLE) + 3) >> 2 << 2) - (bitmap_info.bmiHeader.biWidth * sizeof(RGBTRIPLE));
			for(temp_idx = 0; temp_idx < temp_idx_max ; temp_idx++)
			{
				if(temp_idx % bitmap_info.bmiHeader.biWidth == 0 && temp_idx != 0)
				{
					printf("] - %d\n[",temp_idx / bitmap_info.bmiHeader.biWidth);
					if(bit_mod > 0) fseek(bitmap,bit_mod,SEEK_CUR);
				}
				fread(&rgbtriple,sizeof(RGBTRIPLE),1,bitmap);
				printf("(%3d.%3d.%3d) ",rgbtriple.rgbtRed,rgbtriple.rgbtGreen,rgbtriple.rgbtBlue);
				//printf("0x%02X%02X%02X ",rgbtriple.rgbtRed,rgbtriple.rgbtGreen,rgbtriple.rgbtBlue);
			}
			printf("] - %d\n",temp_idx / bitmap_info.bmiHeader.biWidth);
			break;

		case 32:
			//RGBTRIPLE rgb24;
			break;
	}

	free(rgbquad);
	fclose(bitmap);
	return 0;
}

